// Copyright 2015-2016 Espressif Systems (Shanghai) PTE LTD
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at

//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef _DRIVER_LEDC_PWM_H_
#define _DRIVER_LEDC_PWM_H_

#include "soc/ledc_reg.h"

#ifdef __cplusplus
extern "C" {
#endif

#if 1
/*--------------------------------------------------
                   HSCHX_LEDC_PWM
---------------------------------------------------*/
#define LEDC_HSCHX_CONF0_REG(CHANNEL)  (LEDC_HSCH0_CONF0_REG+0X14*(CHANNEL)) 
#define LEDC_HSCHX_HPOINT_REG(CHANNEL) (LEDC_HSCH0_HPOINT_REG+0X14*(CHANNEL))
#define LEDC_HSCHX_DUTY_REG(CHANNEL)   (LEDC_HSCH0_DUTY_REG+0X14*(CHANNEL))
#define LEDC_HSCHX_CONF1_REG(CHANNEL)   (LEDC_HSCH0_CONF1_REG+0X14*(CHANNEL))
#define LEDC_HSCHX_DUTY_R_REG(CHANNEL) (LEDC_HSCH0_DUTY_R_REG+0X14*(CHANNEL))
/*-------------------------------------------------
                   LSCHX_LEDC_PWM
--------------------------------------------------*/
#define LEDC_LSCHX_CONF0_REG(CHANNEL)  (LEDC_LSCH0_CONF0_REG+0X14*(CHANNEL)) 
#define LEDC_LSCHX_HPOINT_REG(CHANNEL) (LEDC_LSCH0_HPOINT_REG+0X14*(CHANNEL))
#define LEDC_LSCHX_DUTY_REG(CHANNEL)   (LEDC_LSCH0_DUTY_REG+0X14*(CHANNEL))
#define LEDC_LSCHX_CONF1_REG(CHANNEL)   (LEDC_LSCH0_CONF1_REG+0X14*(CHANNEL))
#define LEDC_LSCHX_DUTY_R_REG(CHANNEL) (LEDC_LSCH0_DUTY_R_REG+0X14*(CHANNEL))

/*---------------------------------------------------
               HTIMERX_LEDC_PWM
---------------------------------------------------*/
#define LEDC_HSTIMERX_CONF_REG(TIME) (LEDC_HSTIMER0_CONF_REG+0X08*(TIME))
#define LEDC_HSTIMERX_VALUE_REG(TIME) (LEDC_HSTIMER0_VALUE_REG+0X08*(TIME))
/*----------------------------------------------
               LTIMERX_LEDC_PWM
-----------------------------------------------*/
#define LEDC_LSTIMERX_CONF_REG(TIME) (LEDC_LSTIMER0_CONF_REG+0X08*(TIME))
#define LEDC_LSTIMERX_VALUE_REG(TIME) (LEDC_LSTIMER0_VALUE_REG+0X08*(TIME))
/*-----------------------------------------------
                    REG OPT
-----------------------------------------------*/
#define LEDC_GET_CLK_EN()  GET_PERI_REG_BITS2(LEDC_HSCH0_CONF0_REG , LEDC_CLK_EN_V, LEDC_CLK_EN_S)
#define LEDC_SET_CLK_EN(val)  SET_PERI_REG_BITS(LEDC_HSCH0_CONF0_REG ,LEDC_CLK_EN_V,(val),LEDC_CLK_EN_S)

#define LEDC_GET_IDLE_LV_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF0_REG(CHANNEL) , LEDC_IDLE_LV_HSCH0_V, LEDC_IDLE_LV_HSCH0_S)
#define LEDC_SET_IDLE_LV_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF0_REG(CHANNEL),LEDC_IDLE_LV_HSCH0_V,(val),LEDC_IDLE_LV_HSCH0_S)
#define LEDC_GET_SIG_OUT_EN_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF0_REG(CHANNEL) , LEDC_SIG_OUT_EN_HSCH0_V, LEDC_SIG_OUT_EN_HSCH0_S)
#define LEDC_SET_SIG_OUT_EN_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF0_REG(CHANNEL) ,LEDC_SIG_OUT_EN_HSCH0_V,(val),LEDC_SIG_OUT_EN_HSCH0_S)
#define LEDC_GET_TIMER_SEL_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF0_REG(CHANNEL), LEDC_TIMER_SEL_HSCH0_V, LEDC_TIMER_SEL_HSCH0_S)
#define LEDC_SET_TIMER_SEL_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF0_REG(CHANNEL) ,LEDC_TIMER_SEL_HSCH0_V,(val),LEDC_TIMER_SEL_HSCH0_S)

#define LEDC_GET_HPOINT_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_HPOINT_REG(CHANNEL) , LEDC_HPOINT_HSCH0_V, LEDC_HPOINT_HSCH0_S)
#define LEDC_SET_HPOINT_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_HPOINT_REG(CHANNEL) ,LEDC_HPOINT_HSCH0_V,(val),LEDC_HPOINT_HSCH0_S)

#define LEDC_GET_DUTY_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_DUTY_REG(CHANNEL) , LEDC_DUTY_HSCH0_V, LEDC_DUTY_HSCH0_S)
#define LEDC_SET_DUTY_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_DUTY_REG(CHANNEL) ,LEDC_DUTY_HSCH0_V,(val),LEDC_DUTY_HSCH0_S)

#define LEDC_GET_DUTY_START_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_START_HSCH0_V, LEDC_DUTY_START_HSCH0_S)
#define LEDC_SET_DUTY_START_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_START_HSCH0_V,(val),LEDC_DUTY_START_HSCH0_S)
#define LEDC_GET_DUTY_INC_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_INC_HSCH0_V, LEDC_DUTY_INC_HSCH0_S)
#define LEDC_SET_DUTY_INC_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_INC_HSCH0_V,(val),LEDC_DUTY_INC_HSCH0_S)
#define LEDC_GET_DUTY_NUM_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_NUM_HSCH0_V, LEDC_DUTY_NUM_HSCH0_S)
#define LEDC_SET_DUTY_NUM_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_NUM_HSCH0_V,(val),LEDC_DUTY_NUM_HSCH0_S)
#define LEDC_GET_DUTY_CYCLE_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_CYCLE_HSCH0_V, LEDC_DUTY_CYCLE_HSCH0_S)
#define LEDC_SET_DUTY_CYCLE_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_CYCLE_HSCH0_V,(val),LEDC_DUTY_CYCLE_HSCH0_S)
#define LEDC_GET_DUTY_SCALE_HSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_SCALE_HSCH0_V, LEDC_DUTY_SCALE_HSCH0_S)
#define LEDC_SET_DUTY_SCALE_HSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_HSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_SCALE_HSCH0_V,(val),LEDC_DUTY_SCALE_HSCH0_S)
#define LEDC_GET_DUTY_HSCHX_R(CHANNEL)  GET_PERI_REG_BITS2(LEDC_HSCHX_DUTY_R_REG(CHANNEL) , LEDC_DUTY_HSCH0_V, LEDC_DUTY_HSCH0_S)


#define LEDC_GET_PARA_UP_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF0_REG(CHANNEL) , LEDC_PARA_UP_LSCH0_V, LEDC_PARA_UP_LSCH0_S)
#define LEDC_SET_PARA_UP_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF0_REG(CHANNEL) ,LEDC_PARA_UP_LSCH0_V,(val),LEDC_PARA_UP_LSCH0_S)
#define LEDC_GET_IDLE_LV_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF0_REG(CHANNEL) , LEDC_IDLE_LV_LSCH0_V, LEDC_IDLE_LV_LSCH0_S)
#define LEDC_SET_IDLE_LV_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF0_REG(CHANNEL) ,LEDC_IDLE_LV_LSCH0_V,(val),LEDC_IDLE_LV_LSCH0_S)
#define LEDC_GET_SIG_OUT_EN_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF0_REG(CHANNEL) , LEDC_SIG_OUT_EN_LSCH0_V, LEDC_SIG_OUT_EN_LSCH0_S)
#define LEDC_SET_SIG_OUT_EN_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF0_REG(CHANNEL) ,LEDC_SIG_OUT_EN_LSCH0_V,(val),LEDC_SIG_OUT_EN_LSCH0_S)
#define LEDC_GET_TIMER_SEL_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF0_REG(CHANNEL) , LEDC_TIMER_SEL_LSCH0_V, LEDC_TIMER_SEL_LSCH0_S)
#define LEDC_SET_TIMER_SEL_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF0_REG(CHANNEL) ,LEDC_TIMER_SEL_LSCH0_V,(val),LEDC_TIMER_SEL_LSCH0_S)

#define LEDC_GET_HPOINT_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_HPOINT_REG(CHANNEL) , LEDC_HPOINT_LSCH0_V, LEDC_HPOINT_LSCH0_S)
#define LEDC_SET_HPOINT_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_HPOINT_REG(CHANNEL) ,LEDC_HPOINT_LSCH0_V,(val),LEDC_HPOINT_LSCH0_S)

#define LEDC_GET_DUTY_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_DUTY_REG(CHANNEL) , LEDC_DUTY_LSCH0_V, LEDC_DUTY_LSCH0_S)
#define LEDC_SET_DUTY_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_DUTY_REG(CHANNEL) ,LEDC_DUTY_LSCH0_V,(val),LEDC_DUTY_LSCH0_S)

#define LEDC_GET_DUTY_START_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_START_LSCH0_V, LEDC_DUTY_START_LSCH0_S)
#define LEDC_SET_DUTY_START_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_START_LSCH0_V,(val),LEDC_DUTY_START_LSCH0_S)
#define LEDC_GET_DUTY_INC_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_INC_LSCH0_V, LEDC_DUTY_INC_LSCH0_S)
#define LEDC_SET_DUTY_INC_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_INC_LSCH0_V,(val),LEDC_DUTY_INC_LSCH0_S)
#define LEDC_GET_DUTY_NUM_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_NUM_LSCH0_V, LEDC_DUTY_NUM_LSCH0_S)
#define LEDC_SET_DUTY_NUM_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_NUM_LSCH0_V,(val),LEDC_DUTY_NUM_LSCH0_S)
#define LEDC_GET_DUTY_CYCLE_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_CYCLE_LSCH0_V, LEDC_DUTY_CYCLE_LSCH0_S)
#define LEDC_SET_DUTY_CYCLE_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_CYCLE_LSCH0_V,(val),LEDC_DUTY_CYCLE_LSCH0_S)
#define LEDC_GET_DUTY_SCALE_LSCHX(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_CONF1_REG(CHANNEL) , LEDC_DUTY_SCALE_LSCH0_V, LEDC_DUTY_SCALE_LSCH0_S)
#define LEDC_SET_DUTY_SCALE_LSCHX(CHANNEL,val)  SET_PERI_REG_BITS(LEDC_LSCHX_CONF1_REG(CHANNEL) ,LEDC_DUTY_SCALE_LSCH0_V,(val),LEDC_DUTY_SCALE_LSCH0_S)

#define LEDC_GET_DUTY_LSCHX_R(CHANNEL)  GET_PERI_REG_BITS2(LEDC_LSCHX_DUTY_R_REG(CHANNEL) , LEDC_DUTY_LSCH0_V, LEDC_DUTY_LSCH0_S)



#define LEDC_GET_TICK_SEL_HSTIMERX(TIME)  GET_PERI_REG_BITS2(LEDC_HSTIMERX_CONF_REG(TIME) , LEDC_TICK_SEL_HSTIMER0_V, LEDC_TICK_SEL_HSTIMER0_S)
#define LEDC_SET_TICK_SEL_HSTIMERX(TIME,val)  SET_PERI_REG_BITS(LEDC_HSTIMERX_CONF_REG(TIME) ,LEDC_TICK_SEL_HSTIMER0_V,(val),LEDC_TICK_SEL_HSTIMER0_S)
#define LEDC_GET_HSTIMERX_RST(TIME)  GET_PERI_REG_BITS2(LEDC_HSTIMERX_CONF_REG(TIME) , LEDC_HSTIMER0_RST_V, LEDC_HSTIMER0_RST_S)
#define LEDC_SET_HSTIMERX_RST(TIME,val)  SET_PERI_REG_BITS(LEDC_HSTIMERX_CONF_REG(TIME) ,LEDC_HSTIMER0_RST_V,(val),LEDC_HSTIMER0_RST_S)
#define LEDC_GET_HSTIMERX_PAUSE(TIME)  GET_PERI_REG_BITS2(LEDC_HSTIMERX_CONF_REG(TIME) , LEDC_HSTIMER0_PAUSE_V, LEDC_HSTIMER0_PAUSE_S)
#define LEDC_SET_HSTIMERX_PAUSE(TIME,val)  SET_PERI_REG_BITS(LEDC_HSTIMERX_CONF_REG(TIME) ,LEDC_HSTIMER0_PAUSE_V,(val),LEDC_HSTIMER0_PAUSE_S)
#define LEDC_GET_DIV_NUM_HSTIMERX(TIME)  GET_PERI_REG_BITS2(LEDC_HSTIMERX_CONF_REG(TIME) , LEDC_DIV_NUM_HSTIMER0_V, LEDC_DIV_NUM_HSTIMER0_S)
#define LEDC_SET_DIV_NUM_HSTIMERX(TIME,val)  SET_PERI_REG_BITS(LEDC_HSTIMERX_CONF_REG(TIME) ,LEDC_DIV_NUM_HSTIMER0_V,(val),LEDC_DIV_NUM_HSTIMER0_S)
#define LEDC_GET_HSTIMERX_LIM(TIME)  GET_PERI_REG_BITS2(LEDC_HSTIMERX_CONF_REG(TIME) , LEDC_HSTIMER0_LIM_V, LEDC_HSTIMER0_LIM_S)
#define LEDC_SET_HSTIMERX_LIM(TIME,val)  SET_PERI_REG_BITS(LEDC_HSTIMERX_CONF_REG(TIME) ,LEDC_HSTIMER0_LIM_V,(val),LEDC_HSTIMER0_LIM_S)

#define LEDC_GET_HSTIMERX_CNT(TIME)  GET_PERI_REG_BITS2(LEDC_HSTIMERX_VALUE_REG(TIME) , LEDC_HSTIMER0_CNT_V, LEDC_HSTIMER0_CNT_S)

#define LEDC_GET_LSTIMERX_PARA_UP(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_CONF_REG(TIME), LEDC_LSTIMER0_PARA_UP_V, LEDC_LSTIMER0_PARA_UP_S)
#define LEDC_SET_LSTIMERX_PARA_UP(TIME,val)  SET_PERI_REG_BITS(LEDC_LSTIMERX_CONF_REG(TIME),LEDC_LSTIMER0_PARA_UP_V,(val),LEDC_LSTIMER0_PARA_UP_S)
#define LEDC_GET_TICK_SEL_LSTIMERX(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_CONF_REG(TIME) , LEDC_TICK_SEL_LSTIMER0_V, LEDC_TICK_SEL_LSTIMER0_S)
#define LEDC_SET_TICK_SEL_LSTIMERX(TIME,val)  SET_PERI_REG_BITS(LEDC_LSTIMERX_CONF_REG(TIME) ,LEDC_TICK_SEL_LSTIMER0_V,(val),LEDC_TICK_SEL_LSTIMER0_S)
#define LEDC_GET_LSTIMERX_RST(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_CONF_REG(TIME) , LEDC_LSTIMER0_RST_V, LEDC_LSTIMER0_RST_S)
#define LEDC_SET_LSTIMERX_RST(TIME,val)  SET_PERI_REG_BITS(LEDC_LSTIMERX_CONF_REG(TIME) ,LEDC_LSTIMER0_RST_V,(val),LEDC_LSTIMER0_RST_S)
#define LEDC_GET_LSTIMERX_PAUSE(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_CONF_REG(TIME) , LEDC_LSTIMER0_PAUSE_V, LEDC_LSTIMER0_PAUSE_S)
#define LEDC_SET_LSTIMERX_PAUSE(TIME,val)  SET_PERI_REG_BITS(LEDC_LSTIMERX_CONF_REG(TIME) ,LEDC_LSTIMER0_PAUSE_V,(val),LEDC_LSTIMER0_PAUSE_S)
#define LEDC_GET_DIV_NUM_LSTIMERX(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_CONF_REG(TIME) , LEDC_DIV_NUM_LSTIMER0_V, LEDC_DIV_NUM_LSTIMER0_S)
#define LEDC_SET_DIV_NUM_LSTIMERX(TIME,val)  SET_PERI_REG_BITS(LEDC_LSTIMERX_CONF_REG(TIME) ,LEDC_DIV_NUM_LSTIMER0_V,(val),LEDC_DIV_NUM_LSTIMER0_S)
#define LEDC_GET_LSTIMERX_LIM(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_CONF_REG(TIME) , LEDC_LSTIMER0_LIM_V, LEDC_LSTIMER0_LIM_S)
#define LEDC_SET_LSTIMERX_LIM(TIME,val)  SET_PERI_REG_BITS(LEDC_LSTIMERX_CONF_REG(TIME),LEDC_LSTIMER0_LIM_V,(val),LEDC_LSTIMER0_LIM_S)

#define LEDC_GET_LSTIMERX_CNT(TIME)  GET_PERI_REG_BITS2(LEDC_LSTIMERX_VALUE_REG(TIME),LEDC_LSTIMER0_CNT_V,LEDC_LSTIMER0_CNT_S)

#define LEDC_GET_DUTY_CHNGE_END_LSCHX_INT_RAW(CHANNEL) GET_PERI_REG_BITS2(LEDC_INT_RAW_REG , LEDC_DUTY_CHNG_END_LSCH0_INT_RAW_V, (LEDC_DUTY_CHNG_END_LSCH0_INT_RAW_S+(CHANNEL)))
#define LEDC_GET_DUTY_CHNGE_END_HSCHX_INT_RAW(CHANNEL) GET_PERI_REG_BITS2(LEDC_INT_RAW_REG , LEDC_DUTY_CHNG_END_HSCH0_INT_RAW_V, (LEDC_DUTY_CHNG_END_HSCH0_INT_RAW_S+(CHANNEL)))
#define LEDC_GET_LTIMEX_OVF_INT_RAW(TIME)  GET_PERI_REG_BITS2(LEDC_INT_RAW_REG , LEDC_LSTIMER0_OVF_INT_RAW_V, (LEDC_LSTIMER0_OVF_INT_RAW_S+(TIME)))
#define LEDC_GET_HTIMEX_OVF_INT_RAW(TIME)  GET_PERI_REG_BITS2(LEDC_INT_RAW_REG , LEDC_HSTIMER0_OVF_INT_RAW_V, (LEDC_HSTIMER0_OVF_INT_RAW_S+(TIME)))

#define LEDC_GET_DUTY_CHNGE_END_LSCHX_INT(CHANNEL) GET_PERI_REG_BITS2(LEDC_INT_ST_REG , LEDC_DUTY_CHNG_END_LSCH0_INT_ST_V, (LEDC_DUTY_CHNG_END_LSCH0_INT_ST_S+(CHANNEL)))
#define LEDC_GET_DUTY_CHNGE_END_HSCHX_INT(CHANNEL) GET_PERI_REG_BITS2(LEDC_INT_ST_REG , LEDC_DUTY_CHNG_END_HSCH0_INT_ST_V, (LEDC_DUTY_CHNG_END_HSCH0_INT_ST_V+(CHANNEL)))
#define LEDC_GET_LTIMEX_OVF_INT(TIME)  GET_PERI_REG_BITS2(LEDC_INT_ST_REG , LEDC_LSTIMER0_OVF_INT_ST_V, (LEDC_LSTIMER0_OVF_INT_ST_V+(TIME)))
#define LEDC_GET_HTIMEX_OVF_INT(TIME)  GET_PERI_REG_BITS2(LEDC_INT_ST_REG , LEDC_HSTIMER0_OVF_INT_ST_V, (LEDC_HSTIMER0_OVF_INT_ST_S+(TIME)))

#define LEDC_SET_DUTY_CHNG_END_LSCHX_INT_ENA(CHANNEL,val) SET_PERI_REG_BITS(LEDC_INT_ENA_REG ,LEDC_DUTY_CHNG_END_LSCH0_INT_ENA_V,(val),(LEDC_DUTY_CHNG_END_LSCH0_INT_ENA_S+(CHANNEL)))
#define LEDC_SET_DUTY_CHNG_END_HSCHX_INT_ENA(CHANNEL,val) SET_PERI_REG_BITS(LEDC_INT_ENA_REG ,LEDC_DUTY_CHNG_END_HSCH0_INT_ENA_V,(val),(LEDC_DUTY_CHNG_END_HSCH0_INT_ENA_S+(CHANNEL)))
#define LEDC_SET_LSTIMERX_OVF_INT_ENA(TIME,val)  SET_PERI_REG_BITS(LEDC_INT_ENA_REG ,LEDC_LSTIMER0_OVF_INT_ENA_V,(val),(LEDC_LSTIMER0_OVF_INT_ENA_S+(TIME)))
#define LEDC_SET_HSTIMERX_OVF_INT_ENA(TIME,val)  SET_PERI_REG_BITS(LEDC_INT_ENA_REG ,LEDC_HSTIMER0_OVF_INT_ENA_V,(val),(LEDC_HSTIMER0_OVF_INT_ENA_S+(TIME)))

#define LEDC_SET_DUTY_CHNG_END_LSCHX_INT_CLR(CHANNEL,val)  WRITE_PERI_REG(LEDC_INT_CLR_REG,((val) & LEDC_DUTY_CHNG_END_LSCH0_INT_CLR_V )<<(LEDC_DUTY_CHNG_END_LSCH0_INT_CLR_S+(CHANNEL)))
#define LEDC_SET_DUTY_CHNG_END_HSCHX_INT_CLR(CHANNEL,val)  WRITE_PERI_REG(LEDC_INT_CLR_REG,((val) & LEDC_DUTY_CHNG_END_HSCH0_INT_CLR_V )<<(LEDC_DUTY_CHNG_END_HSCH0_INT_CLR_S+(CHANNEL)))
#define LEDC_SET_HSTIMERX_OVF_INT_CLR(TIME,val)  WRITE_PERI_REG(LEDC_INT_CLR_REG,((val) & LEDC_HSTIMER0_OVF_INT_CLR_V )<<(LEDC_HSTIMER0_OVF_INT_CLR_S+(TIME)))
#define LEDC_SET_HSTIMERX_OVF_INT_CLR(TIME,val)  WRITE_PERI_REG(LEDC_INT_CLR_REG,((val) & LEDC_HSTIMER0_OVF_INT_CLR_V )<<(LEDC_HSTIMER0_OVF_INT_CLR_S+(TIME)))

#define LEDC_GET_APB_CLK_SEL()  GET_PERI_REG_BITS2(LEDC_CONF_REG , LEDC_APB_CLK_SEL_V, LEDC_APB_CLK_SEL_S)
#define LEDC_SET_APB_CLK_SEL(val)  SET_PERI_REG_BITS(LEDC_CONF_REG ,LEDC_APB_CLK_SEL_V,(val),LEDC_APB_CLK_SEL_S)

#define LEDC_GET_DAT()  GET_PERI_REG_BITS2(LEDC_DATE_REG , LEDC_DATE_V, LEDC_DATE_S)
#define LEDC_SET_DAT(val)  SET_PERI_REG_BITS(LEDC_DATE_REG ,LEDC_DATE_V,(val),LEDC_DATE_S)
#endif
enum ledc_pwm_mode{
    LEDC_HIGH_MODE=0,
	LEDC_LOW_MOD,
};
enum ledc_pwm_intr_type{
    LEDC_INTR_DISABLE=0,
	LEDC_CHANGE_END,
};
enum ledc_pwm_increase_direction{
    LEDC_CHANGE_DECREASE=0,
    LEDC_CHANGE_INCREASE=1,
};
enum ledc_timer_source{
    LEDC_TIME0=0,
	LEDC_TIME1,
	LEDC_TIME2,
	LEDC_TIME3,
};
enum ledc_pwm_channel{
    LEDC_PWM_CHANNEL0=0,
	LEDC_PWM_CHANNEL1,
	LEDC_PWM_CHANNEL2,
	LEDC_PWM_CHANNEL3,
	LEDC_PWM_CHANNEL4,
	LEDC_PWM_CHANNEL5,
	LEDC_PWM_CHANNEL6,
	LEDC_PWM_CHANNEL7,
};
enum ledc_pwm_duty_depth{
    LEDC_PWM_DUTY_DEPTH_10_BIT=10,
	LEDC_PWM_DUTY_DEPTH_11_BIT=11,
	LEDC_PWM_DUTY_DEPTH_12_BIT=12,
	LEDC_PWM_DUTY_DEPTH_13_BIT=13,
	LEDC_PWM_DUTY_DEPTH_14_BIT=14,
	LEDC_PWM_DUTY_DEPTH_15_BIT=15,
};
typedef struct ledc_pwm_channel_config{
    uint8_t gpio_num;
	enum ledc_pwm_channel channel;
	enum ledc_pwm_intr_type intr_enable;
	/*if selet same time,the fre and the ledc_depth must be same*/
	enum ledc_timer_source time;
	uint32_t fre_hz;
	uint16_t duty;
	enum ledc_pwm_duty_depth ledc_pre_depth;
}ledc_channel_config;


void ledc_pwm_channel_config(enum ledc_pwm_mode mode,ledc_channel_config* ledc_channel_config);
void ledc_pwm_start(enum ledc_pwm_mode mode,enum ledc_pwm_channel channel);
void ledc_pwm_stop(enum ledc_pwm_mode mode,enum ledc_pwm_channel channel,uint8_t idle_level);
void ledc_pwm_set_fre(enum ledc_pwm_mode mode,enum ledc_pwm_channel channel,uint32_t fre_hz);
void ledc_pwm_set_duty(enum ledc_pwm_mode mode,enum ledc_pwm_channel channel,uint16_t duty);
uint32_t ledc_pwm_get_duty(enum ledc_pwm_mode mode,enum ledc_pwm_channel channel);
uint32_t ledc_pwm_get_fre_hz(enum ledc_pwm_mode mode,enum ledc_pwm_channel channel);

void ledc_pwm_intr_register(void (* fn)(void* ),void * arg);
void ledc_pwm_set_gradient(enum ledc_pwm_mode mode,uint8_t channel,uint32_t duty,enum ledc_pwm_increase_direction gradule_direction,
	                                uint16_t gradule_num,uint16_t duty_cyle_num,uint16_t duty_scale);

#ifdef __cplusplus
}
#endif

#endif /* _DRIVER_LEDC_PWM_H_ */
